#
# $Id$
#   
# Copyright (C) 2003 Kai Sterker <kaisterker@linuxgames.com>
# Part of the Adonthell Project http://adonthell.linuxgames.com
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY.
#
# See the COPYING file for more details.
#

import item
import adonthell

#
# A basic item that can be transformed into a different item
#
class transformable_item (item.item):

    def __init__ (self):
        # -- init base class
        item.item.__init__(self)

        # -- item required for the transformation
        self.Agent = ""

        # -- result of the transformation
        self.Result = ""

        
    def combine (self, item):
        instance = item.get_instance ()
        
        # -- is item the required agent?
        if instance.Name == self.Agent or instance.is_a (self.Agent):
            return adonthell.item_storage_get (self.Result)
        
        return None
        
    
    def put_state (self, file):
        # -- save state of parent class
        item.item.put_state (self, file)

        # -- save attributes
        file.put_string (self.Agent)
        file.put_string (self.Result)
        
        
    def get_state (self, file):
        # -- load state of parent class
        item.item.get_state (self, file)
        
        # -- save attributes
        self.Agent = file.get_string ()
        self.Result = file.get_string ()
        
